package de.intevation.flys.artifacts.model.sq;

import org.apache.log4j.Logger;

import de.intevation.artifacts.Artifact;
import de.intevation.artifacts.CallContext;

import de.intevation.flys.artifacts.FLYSArtifact;

import de.intevation.flys.artifacts.model.DataFacet;
import de.intevation.flys.artifacts.model.FacetTypes;

import de.intevation.flys.artifacts.states.DefaultState.ComputeType;

public class SQOverviewFacet
extends DataFacet
implements FacetTypes 
{
    private static final Logger logger = Logger.getLogger(SQOverviewFacet.class);

    protected int fractionIdx;

    public SQOverviewFacet() {
    }

    public SQOverviewFacet(
        int    idx,
        int    fractionIdx,
        String name,
        String description,
        String hash,
        String stateId
    ) {
        super(idx, name, description, ComputeType.ADVANCE, hash, stateId);
        this.fractionIdx = fractionIdx;
    }


    @Override
    public Object getData(Artifact artifact, CallContext context) {
        logger.debug("SQOverviewFacet.getData");

        switch(fractionIdx) {
            case 0: return "sq_relation_a";
            case 1: return "sq_relation_b";
            case 2: return "sq_relation_c";
            case 3: return "sq_relation_d";
            case 4: return "sq_relation_e";
            case 5: return "sq_relation_f";
            default: return null;
        }
    }


    @Override
    public SQOverviewFacet deepCopy() {
        SQOverviewFacet copy = new SQOverviewFacet();
        copy.set(this);

        return copy;
    }
}
